
# デフォルトのgalleryでは、Nextボタンやスライドショーボタン使用時でも、マウスクリック時同様に、現在ボタンの最後の画像にくると閉じてしまいます。
# span_buttonsフィールドをTrueにすると次のボタンに移動するようになりますが、ボタンだけでなくマウスで普通にクリックした時も次のボタンに移動してしまいます。
# このプラグインはspan_buttonsに関わらず、マウスでクリックした時は今迄どおりの動作をさせるようにします。
#
# Gallery クラスのshow関数を置き換えているため、show関数が変更されると動作しなくなります。
# Aug 8, 2017動作確認
# Jan 28, 2014動作確認
init -100 python:
    def _gallery_show(self, button=0, image=0):
            """
            Starts showing gallery images.

            `button`
                The index of the button to start showing.
            """

            # A list of (button, image) index pairs for all of the images we know
            # about.
            all_images = [ ]

            # A list of (button, image) index pairs for all of the unlocked
            # images.
            unlocked_images = [ ]

            for bi, b in enumerate(self.button_list):

                all_unlocked = True

                for ii, i in enumerate(b.images):

                    all_images.append((bi, ii))

                    unlocked = i.check_unlock(all_unlocked)

                    if unlocked:
                        unlocked_images.append((bi, ii))
                    else:
                        all_unlocked = False

            self.slideshow = False

            # Loop, displaying the images.
            while True:

                b = self.button_list[button]
                i = b.images[image]

                result = i.show((button, image) not in unlocked_images, image, len(b.images))

                # Default action for click.
                #追加部分
                if result is True:
                    result = "mouse"
                #追加部分

                if result == 'return':
                    break

                # At this point, result is either 'next', "next_unlocked", "previous", or "previous_unlocked"
                # Go through the common advance code.

                if self.unlocked_advance:
                    images = unlocked_images
                else:
                    images = all_images

                if (button, image) in images:
                    index = images.index((button, image))
                else:
                    index = -1

                if result.startswith('previous'):
                    index -= 1
                else:
                    index += 1

                if index < 0 or index >= len(images):
                    break

                new_button, new_image = images[index]

                #追加部分
                if not self.span_buttons or result == "mouse":
                #追加部分
                    if new_button != button:
                        break

                button = new_button
                image = new_image

            renpy.transition(self.transition)

    Gallery.show = _gallery_show
